/*
 * $Id$
 */

package org.apache.maven.continuum.model.project;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import org.apache.maven.continuum.model.scm.ChangeFile;
import org.apache.maven.continuum.model.scm.ChangeSet;
import org.apache.maven.continuum.model.scm.ScmResult;
import org.apache.maven.continuum.model.system.ContinuumUser;
import org.apache.maven.continuum.model.system.Installation;
import org.apache.maven.continuum.model.system.NotificationAddress;
import org.apache.maven.continuum.model.system.Permission;
import org.apache.maven.continuum.model.system.SystemConfiguration;
import org.apache.maven.continuum.model.system.UserGroup;

/**
 * Class BuildDefinition.
 * 
 * @version $Revision$ $Date$
 */
public class BuildDefinition implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field id
     */
    private int id = 0;

    /**
     * Field defaultForProject
     */
    private boolean defaultForProject = false;

    /**
     * Field goals
     */
    private String goals;

    /**
     * Field arguments
     */
    private String arguments;

    /**
     * Field buildFile
     */
    private String buildFile;

    /**
     * Field schedule
     */
    private Schedule schedule;

    /**
     * Field profile
     */
    private Profile profile;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method equals
     * 
     * @param other
     */
    public boolean equals(Object other)
    {
        if ( this == other)
        {
            return true;
        }
        
        if ( !(other instanceof BuildDefinition) )
        {
            return false;
        }
        
        BuildDefinition that = (BuildDefinition) other;
        return this.id== that.getId();
    } //-- boolean equals(Object) 

    /**
     * Method getArguments
     */
    public String getArguments()
    {
        return this.arguments;
    } //-- String getArguments() 

    /**
     * Method getBuildFile
     */
    public String getBuildFile()
    {
        return this.buildFile;
    } //-- String getBuildFile() 

    /**
     * Method getGoals
     */
    public String getGoals()
    {
        return this.goals;
    } //-- String getGoals() 

    /**
     * Method getId
     */
    public int getId()
    {
        return this.id;
    } //-- int getId() 

    /**
     * Method getProfile
     */
    public Profile getProfile()
    {
        return this.profile;
    } //-- Profile getProfile() 

    /**
     * Method getSchedule
     */
    public Schedule getSchedule()
    {
        return this.schedule;
    } //-- Schedule getSchedule() 

    /**
     * Method hashCode
     */
    public int hashCode()
    {
        long tmp;
        return (int) id;
    } //-- int hashCode() 

    /**
     * Method isDefaultForProject
     */
    public boolean isDefaultForProject()
    {
        return this.defaultForProject;
    } //-- boolean isDefaultForProject() 

    /**
     * Method setArguments
     * 
     * @param arguments
     */
    public void setArguments(String arguments)
    {
        this.arguments = arguments;
    } //-- void setArguments(String) 

    /**
     * Method setBuildFile
     * 
     * @param buildFile
     */
    public void setBuildFile(String buildFile)
    {
        this.buildFile = buildFile;
    } //-- void setBuildFile(String) 

    /**
     * Method setDefaultForProject
     * 
     * @param defaultForProject
     */
    public void setDefaultForProject(boolean defaultForProject)
    {
        this.defaultForProject = defaultForProject;
    } //-- void setDefaultForProject(boolean) 

    /**
     * Method setGoals
     * 
     * @param goals
     */
    public void setGoals(String goals)
    {
        this.goals = goals;
    } //-- void setGoals(String) 

    /**
     * Method setId
     * 
     * @param id
     */
    public void setId(int id)
    {
        this.id = id;
    } //-- void setId(int) 

    /**
     * Method setProfile
     * 
     * @param profile
     */
    public void setProfile(Profile profile)
    {
        this.profile = profile;
    } //-- void setProfile(Profile) 

    /**
     * Method setSchedule
     * 
     * @param schedule
     */
    public void setSchedule(Schedule schedule)
    {
        this.schedule = schedule;
    } //-- void setSchedule(Schedule) 

}
