/*
 * $Id$
 */

package org.apache.maven.continuum.model.project;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import org.apache.maven.continuum.model.scm.ChangeFile;
import org.apache.maven.continuum.model.scm.ChangeSet;
import org.apache.maven.continuum.model.scm.ScmResult;
import org.apache.maven.continuum.model.system.ContinuumUser;
import org.apache.maven.continuum.model.system.Installation;
import org.apache.maven.continuum.model.system.NotificationAddress;
import org.apache.maven.continuum.model.system.Permission;
import org.apache.maven.continuum.model.system.SystemConfiguration;
import org.apache.maven.continuum.model.system.UserGroup;

/**
 * Class BuildResult.
 * 
 * @version $Revision$ $Date$
 */
public class BuildResult implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field project
     */
    private Project project;

    /**
     * Field id
     */
    private int id = 0;

    /**
     * Field buildNumber
     */
    private int buildNumber = 0;

    /**
     * Field state
     */
    private int state = 0;

    /**
     * Field trigger
     */
    private int trigger = 0;

    /**
     * Field startTime
     */
    private long startTime = 0;

    /**
     * Field endTime
     */
    private long endTime = 0;

    /**
     * Field error
     */
    private String error;

    /**
     * Field success
     */
    private boolean success = false;

    /**
     * Field exitCode
     */
    private int exitCode = 0;

    /**
     * Field scmResult
     */
    private ScmResult scmResult;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method breakProjectAssociation
     * 
     * @param project
     */
    public void breakProjectAssociation(Project project)
    {
        if ( this.project != project )
        {
            throw new IllegalStateException( "project isn't associated." );
        }
        
        this.project = null;
    } //-- void breakProjectAssociation(Project) 

    /**
     * Method createProjectAssociation
     * 
     * @param project
     */
    public void createProjectAssociation(Project project)
    {
        if ( this.project != null )
        {
            breakProjectAssociation( this.project );
        }
        
        this.project = project;
    } //-- void createProjectAssociation(Project) 

    /**
     * Method equals
     * 
     * @param other
     */
    public boolean equals(Object other)
    {
        if ( this == other)
        {
            return true;
        }
        
        if ( !(other instanceof BuildResult) )
        {
            return false;
        }
        
        BuildResult that = (BuildResult) other;
        return this.id== that.getId();
    } //-- boolean equals(Object) 

    /**
     * Method getBuildNumber
     */
    public int getBuildNumber()
    {
        return this.buildNumber;
    } //-- int getBuildNumber() 

    /**
     * Method getEndTime
     */
    public long getEndTime()
    {
        return this.endTime;
    } //-- long getEndTime() 

    /**
     * Method getError
     */
    public String getError()
    {
        return this.error;
    } //-- String getError() 

    /**
     * Method getExitCode
     */
    public int getExitCode()
    {
        return this.exitCode;
    } //-- int getExitCode() 

    /**
     * Method getId
     */
    public int getId()
    {
        return this.id;
    } //-- int getId() 

    /**
     * Method getProject
     */
    public Project getProject()
    {
        return this.project;
    } //-- Project getProject() 

    /**
     * Method getScmResult
     */
    public ScmResult getScmResult()
    {
        return this.scmResult;
    } //-- ScmResult getScmResult() 

    /**
     * Method getStartTime
     */
    public long getStartTime()
    {
        return this.startTime;
    } //-- long getStartTime() 

    /**
     * Method getState
     */
    public int getState()
    {
        return this.state;
    } //-- int getState() 

    /**
     * Method getTrigger
     */
    public int getTrigger()
    {
        return this.trigger;
    } //-- int getTrigger() 

    /**
     * Method hashCode
     */
    public int hashCode()
    {
        long tmp;
        return (int) id;
    } //-- int hashCode() 

    /**
     * Method isSuccess
     */
    public boolean isSuccess()
    {
        return this.success;
    } //-- boolean isSuccess() 

    /**
     * Method setBuildNumber
     * 
     * @param buildNumber
     */
    public void setBuildNumber(int buildNumber)
    {
        this.buildNumber = buildNumber;
    } //-- void setBuildNumber(int) 

    /**
     * Method setEndTime
     * 
     * @param endTime
     */
    public void setEndTime(long endTime)
    {
        this.endTime = endTime;
    } //-- void setEndTime(long) 

    /**
     * Method setError
     * 
     * @param error
     */
    public void setError(String error)
    {
        this.error = error;
    } //-- void setError(String) 

    /**
     * Method setExitCode
     * 
     * @param exitCode
     */
    public void setExitCode(int exitCode)
    {
        this.exitCode = exitCode;
    } //-- void setExitCode(int) 

    /**
     * Method setId
     * 
     * @param id
     */
    public void setId(int id)
    {
        this.id = id;
    } //-- void setId(int) 

    /**
     * Method setProject
     * 
     * @param project
     */
    public void setProject(Project project)
    {
        if ( this.project != null )
        {
            this.project.breakBuildResultAssociation( this );
        }
        
        this.project = project;
        
        if ( project != null )
        {
            this.project.createBuildResultAssociation( this );
        }
    } //-- void setProject(Project) 

    /**
     * Method setScmResult
     * 
     * @param scmResult
     */
    public void setScmResult(ScmResult scmResult)
    {
        this.scmResult = scmResult;
    } //-- void setScmResult(ScmResult) 

    /**
     * Method setStartTime
     * 
     * @param startTime
     */
    public void setStartTime(long startTime)
    {
        this.startTime = startTime;
    } //-- void setStartTime(long) 

    /**
     * Method setState
     * 
     * @param state
     */
    public void setState(int state)
    {
        this.state = state;
    } //-- void setState(int) 

    /**
     * Method setSuccess
     * 
     * @param success
     */
    public void setSuccess(boolean success)
    {
        this.success = success;
    } //-- void setSuccess(boolean) 

    /**
     * Method setTrigger
     * 
     * @param trigger
     */
    public void setTrigger(int trigger)
    {
        this.trigger = trigger;
    } //-- void setTrigger(int) 

}
