/*
 * $Id$
 */

package org.apache.maven.continuum.model.scm;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import java.util.List;
import org.apache.maven.continuum.model.project.BuildDefinition;
import org.apache.maven.continuum.model.project.BuildResult;
import org.apache.maven.continuum.model.project.Profile;
import org.apache.maven.continuum.model.project.Project;
import org.apache.maven.continuum.model.project.ProjectDependency;
import org.apache.maven.continuum.model.project.ProjectDeveloper;
import org.apache.maven.continuum.model.project.ProjectGroup;
import org.apache.maven.continuum.model.project.ProjectNotifier;
import org.apache.maven.continuum.model.project.Schedule;
import org.apache.maven.continuum.model.system.ContinuumUser;
import org.apache.maven.continuum.model.system.Installation;
import org.apache.maven.continuum.model.system.NotificationAddress;
import org.apache.maven.continuum.model.system.Permission;
import org.apache.maven.continuum.model.system.SystemConfiguration;
import org.apache.maven.continuum.model.system.UserGroup;

/**
 * Class ChangeSet.
 * 
 * @version $Revision$ $Date$
 */
public class ChangeSet implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field author
     */
    private String author;

    /**
     * Field comment
     */
    private String comment;

    /**
     * Field date
     */
    private long date = 0;

    /**
     * Field files
     */
    private java.util.List files;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addFile
     * 
     * @param changeFile
     */
    public void addFile(ChangeFile changeFile)
    {
        getFiles().add( changeFile );
    } //-- void addFile(ChangeFile) 

    /**
     * Method getAuthor
     */
    public String getAuthor()
    {
        return this.author;
    } //-- String getAuthor() 

    /**
     * Method getComment
     */
    public String getComment()
    {
        return this.comment;
    } //-- String getComment() 

    /**
     * Method getDate
     */
    public long getDate()
    {
        return this.date;
    } //-- long getDate() 

    /**
     * Method getFiles
     */
    public java.util.List getFiles()
    {
        if ( this.files == null )
        {
            this.files = new java.util.ArrayList();
        }
        
        return this.files;
    } //-- java.util.List getFiles() 

    /**
     * Method removeFile
     * 
     * @param changeFile
     */
    public void removeFile(ChangeFile changeFile)
    {
        getFiles().remove( changeFile );
    } //-- void removeFile(ChangeFile) 

    /**
     * Method setAuthor
     * 
     * @param author
     */
    public void setAuthor(String author)
    {
        this.author = author;
    } //-- void setAuthor(String) 

    /**
     * Method setComment
     * 
     * @param comment
     */
    public void setComment(String comment)
    {
        this.comment = comment;
    } //-- void setComment(String) 

    /**
     * Method setDate
     * 
     * @param date
     */
    public void setDate(long date)
    {
        this.date = date;
    } //-- void setDate(long) 

    /**
     * Method setFiles
     * 
     * @param files
     */
    public void setFiles(java.util.List files)
    {
        this.files = files;
    } //-- void setFiles(java.util.List) 

}
