/*
 * $Id$
 */

package org.apache.maven.continuum.model.system;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import org.apache.maven.continuum.model.project.BuildDefinition;
import org.apache.maven.continuum.model.project.BuildResult;
import org.apache.maven.continuum.model.project.Profile;
import org.apache.maven.continuum.model.project.Project;
import org.apache.maven.continuum.model.project.ProjectDependency;
import org.apache.maven.continuum.model.project.ProjectDeveloper;
import org.apache.maven.continuum.model.project.ProjectGroup;
import org.apache.maven.continuum.model.project.ProjectNotifier;
import org.apache.maven.continuum.model.project.Schedule;
import org.apache.maven.continuum.model.scm.ChangeFile;
import org.apache.maven.continuum.model.scm.ChangeSet;
import org.apache.maven.continuum.model.scm.ScmResult;

/**
 * Class SystemConfiguration.
 * 
 * @version $Revision$ $Date$
 */
public class SystemConfiguration implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field guestAccountEnabled
     */
    private boolean guestAccountEnabled = true;

    /**
     * Field defaultScheduleDescription
     */
    private String defaultScheduleDescription = "Run hourly";

    /**
     * Field defaultScheduleCronExpression
     */
    private String defaultScheduleCronExpression = "0 0 * * * ?";

    /**
     * Field workingDirectory
     */
    private String workingDirectory;

    /**
     * Field buildOutputDirectory
     */
    private String buildOutputDirectory;

    /**
     * Field baseUrl
     */
    private String baseUrl;

    /**
     * Field companyName
     */
    private String companyName;

    /**
     * Field companyLogoUrl
     */
    private String companyLogoUrl;

    /**
     * Field companyUrl
     */
    private String companyUrl;

    /**
     * Field initialized
     */
    private boolean initialized = false;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method getBaseUrl
     */
    public String getBaseUrl()
    {
        return this.baseUrl;
    } //-- String getBaseUrl() 

    /**
     * Method getBuildOutputDirectory
     */
    public String getBuildOutputDirectory()
    {
        return this.buildOutputDirectory;
    } //-- String getBuildOutputDirectory() 

    /**
     * Method getCompanyLogoUrl
     */
    public String getCompanyLogoUrl()
    {
        return this.companyLogoUrl;
    } //-- String getCompanyLogoUrl() 

    /**
     * Method getCompanyName
     */
    public String getCompanyName()
    {
        return this.companyName;
    } //-- String getCompanyName() 

    /**
     * Method getCompanyUrl
     */
    public String getCompanyUrl()
    {
        return this.companyUrl;
    } //-- String getCompanyUrl() 

    /**
     * Method getDefaultScheduleCronExpression
     */
    public String getDefaultScheduleCronExpression()
    {
        return this.defaultScheduleCronExpression;
    } //-- String getDefaultScheduleCronExpression() 

    /**
     * Method getDefaultScheduleDescription
     */
    public String getDefaultScheduleDescription()
    {
        return this.defaultScheduleDescription;
    } //-- String getDefaultScheduleDescription() 

    /**
     * Method getWorkingDirectory
     */
    public String getWorkingDirectory()
    {
        return this.workingDirectory;
    } //-- String getWorkingDirectory() 

    /**
     * Method isGuestAccountEnabled
     */
    public boolean isGuestAccountEnabled()
    {
        return this.guestAccountEnabled;
    } //-- boolean isGuestAccountEnabled() 

    /**
     * Method isInitialized
     */
    public boolean isInitialized()
    {
        return this.initialized;
    } //-- boolean isInitialized() 

    /**
     * Method setBaseUrl
     * 
     * @param baseUrl
     */
    public void setBaseUrl(String baseUrl)
    {
        this.baseUrl = baseUrl;
    } //-- void setBaseUrl(String) 

    /**
     * Method setBuildOutputDirectory
     * 
     * @param buildOutputDirectory
     */
    public void setBuildOutputDirectory(String buildOutputDirectory)
    {
        this.buildOutputDirectory = buildOutputDirectory;
    } //-- void setBuildOutputDirectory(String) 

    /**
     * Method setCompanyLogoUrl
     * 
     * @param companyLogoUrl
     */
    public void setCompanyLogoUrl(String companyLogoUrl)
    {
        this.companyLogoUrl = companyLogoUrl;
    } //-- void setCompanyLogoUrl(String) 

    /**
     * Method setCompanyName
     * 
     * @param companyName
     */
    public void setCompanyName(String companyName)
    {
        this.companyName = companyName;
    } //-- void setCompanyName(String) 

    /**
     * Method setCompanyUrl
     * 
     * @param companyUrl
     */
    public void setCompanyUrl(String companyUrl)
    {
        this.companyUrl = companyUrl;
    } //-- void setCompanyUrl(String) 

    /**
     * Method setDefaultScheduleCronExpression
     * 
     * @param defaultScheduleCronExpression
     */
    public void setDefaultScheduleCronExpression(String defaultScheduleCronExpression)
    {
        this.defaultScheduleCronExpression = defaultScheduleCronExpression;
    } //-- void setDefaultScheduleCronExpression(String) 

    /**
     * Method setDefaultScheduleDescription
     * 
     * @param defaultScheduleDescription
     */
    public void setDefaultScheduleDescription(String defaultScheduleDescription)
    {
        this.defaultScheduleDescription = defaultScheduleDescription;
    } //-- void setDefaultScheduleDescription(String) 

    /**
     * Method setGuestAccountEnabled
     * 
     * @param guestAccountEnabled
     */
    public void setGuestAccountEnabled(boolean guestAccountEnabled)
    {
        this.guestAccountEnabled = guestAccountEnabled;
    } //-- void setGuestAccountEnabled(boolean) 

    /**
     * Method setInitialized
     * 
     * @param initialized
     */
    public void setInitialized(boolean initialized)
    {
        this.initialized = initialized;
    } //-- void setInitialized(boolean) 

    /**
     * Method setWorkingDirectory
     * 
     * @param workingDirectory
     */
    public void setWorkingDirectory(String workingDirectory)
    {
        this.workingDirectory = workingDirectory;
    } //-- void setWorkingDirectory(String) 

}
